import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
from sklearn.metrics import mean_squared_error
from sklearn.metrics import r2_score
from sklearn.model_selection import train_test_split
df = pd.read_csv('C:/Users/hp/Desktop/549nm.csv',encoding='utf-8')
X=df.iloc[:,0:1].values
y=df.iloc[:,1:2].values

X_train,X_test,y_train,y_test=train_test_split(X,y,
                                               test_size=0.2,
                                               random_state=1)





from sklearn import linear_model
reg=linear_model.LinearRegression(fit_intercept=True,normalize=True)
reg.fit(X_train,y_train)
y_train_pred=reg.predict(X_train)
y_test_pred=reg.predict(X_test)


def mean_relative_error(y_true,y_pred):
    relative_error = np.average(np.abs(y_pred-y_true)/y_true*100,axis=0)
    return relative_error


print('RMSE train:%3f,test:%3f'%(mean_squared_error(y_train,y_train_pred,squared=False),
                               mean_squared_error(y_test,y_test_pred,squared=False)))
print('r2 train:%.3f,test:%.3f'%(r2_score(y_train,y_train_pred),r2_score(y_test,y_test_pred)))

print('RE train:%3f,test:%3f'%(mean_relative_error(y_train,y_train_pred),
                               mean_relative_error(y_test,y_test_pred)))

print('w test:%3f'%reg.coef_)
print('b test:%3f'%reg.intercept_)



plt.scatter(X_test,
            y_test,
            c='steelblue',
            #edgecolor='white',
            marker ='o',
            s=30,
            alpha=0.8,
            )


plt.plot(X_test,y_test_pred,color='steelblue',alpha=0.8,linewidth=0.8)
#plt.xlabel('Reflectance')
#plt.ylabel('SPAD')
plt.xticks((0,0.1,0.2,0.3,0.4),fontproperties = 'Times New Roman', size = 22)
plt.yticks(fontproperties = 'Times New Roman', size = 22)
plt.ylim([0,70])
plt.xlim([0,0.4])
plt.tight_layout()
plt.show()


#testing:
plt.scatter(y_test,
            y_test_pred,
            c='steelblue',
            #edgecolor='white',
            marker ='o',
            s=20,
            alpha=0.8,
            label='Validation set'
            )

#font1 = {'family' : 'Times New Roman','weight' : 'normal','size'   : 22}
#plt.legend(loc='lower left',prop=font1)
x=np.array(y_test).reshape(-1,1)
reg.fit(x,y_test_pred)
y_pred=reg.predict(x)
plt.plot(x,y_pred,color='steelblue',alpha=0.8,linewidth=0.8)
#plt.xlabel('SPAD measured')
#plt.ylabel('SPAD predicted ')


plt.xticks(fontproperties = 'Times New Roman', size = 22)
plt.yticks(fontproperties = 'Times New Roman', size = 22)
plt.ylim([0,70])
plt.xlim([0,70])
plt.tight_layout()
plt.show()


#y_test= sc_y.inverse_transform(y_test)
#y_test_pred= sc_y.inverse_transform(y_test_pred)

plt.plot(range(len(y_test)),y_test,color='b',alpha=0.8,label='Measured value')
plt.plot(range(len(y_test)),y_test_pred,color='r',alpha=0.8,label='Predicted value')
plt.xticks(fontproperties = 'Times New Roman', size = 20)
plt.yticks(fontproperties = 'Times New Roman', size = 20)
plt.ylim([10,70])
plt.xlim([0,135])
font1 = {'family' : 'Times New Roman','weight' : 'normal','size'   : 20}
plt.legend(loc='lower left',prop=font1)
plt.show()
